/* DS18S20 Temperature Sensor Module sample project
*/
#include <OneWire.h>
int temperaturePin=16; // define D10 as input pin connecting to DS18S20 S pin
OneWire ds(temperaturePin); 

unsigned long timer0 = 0, timer1 = 0, timer2 = 0, timer3 = 0;
int icabin_temperature;
 
void setup(void) {
  Serial.begin(9600);
}
 
void loop(void) {
  if(millis() - timer1 > 2000UL){
    read_temperature();
    Serial.println(icabin_temperature);
    timer1 = millis();
  }
}


//This function reads the temperature from a DS18S20 temp sensor
void read_temperature(){
  int HighByte, LowByte, TReading, SignBit, Tc_100, Whole, Fract;
  byte i;
  byte present = 0;
  byte data[12];
  byte addr[8];

  if ( !ds.search(addr)) {
      ds.reset_search();
      return;
  }
  ds.reset();
  ds.select(addr);
  ds.write(0x44,1);

  present = ds.reset();
  ds.select(addr);    
  ds.write(0xBE); 
 
 
  present = ds.reset();
  ds.select(addr);    
  ds.write(0xBE);

  for ( i = 0; i < 9; i++) { 
    data[i] = ds.read();
  }
  LowByte = data[0];
  HighByte = data[1];
  TReading = (HighByte << 8) + LowByte;
  SignBit = TReading & 0x8000;  
  if (SignBit)
  {
    TReading = (TReading ^ 0xffff) + 1;
  }
  Tc_100 = (6 * TReading) + TReading / 4; 
  Whole = Tc_100 / 100; 
  Fract = Tc_100 % 100;
  if (SignBit)
  {
     Whole = (-1)*Whole;
  }
  float ftemp = (((float)Whole) *1.8) + 32.0; //convert to F
  icabin_temperature = (int) ftemp;
}
